import torch
import torch.nn as nn
import torch.nn.functional as F

def smoothexp(x,λ=1.0):
	if not λ==0: λ=1/λ; return (-1-F.elu(-1-x*λ)) / λ
	else: return (x<0.)*x

class Smoothmax(nn.Module):
	def __init__(self,maximum,smoothness=1.0,inplace=False):
		super().__init__()
		self.inplace = inplace
		self.maximum = maximum
		self.smoothness = smoothness
	def forward(self,x):
		if not self.inplace: x = x.clone()
		return self.maximum+smoothexp(x-self.maximum,self.smoothness)

# def debug():
# 	import matplotlib.pyplot as plt
# 	plt.ion()
# 	x = torch.linspace(-3,3,2**12)
# 	for λ in  torch.pow(2.,torch.linspace(-1,-0,5)): plt.plot(x,Smoothmax(0,λ)(x),color="red")
# 	for λ in  torch.pow(2.,torch.linspace( 0, 1,5)): plt.plot(x,Smoothmax(0,λ)(x),color="blue")
# 	for λ in -torch.pow(2.,torch.linspace(-1,-0,5)): plt.plot(x,Smoothmax(0,λ)(x),color="orange")
# 	for λ in -torch.pow(2.,torch.linspace( 0, 1,5)): plt.plot(x,Smoothmax(0,λ)(x),color="cyan")
# 	plt.plot(x,Smoothmax(0, 1)(x),color="black")
# 	plt.plot(x,Smoothmax(0,-1)(x),color="black")
# 	plt.plot(x,Smoothmax(0,0)(x),color="black")
# 	plt.plot(x,Smoothmax(0,-0)(x),color="black")
# 	plt.plot(x,x-Smoothmax(0,-0)(x),color="black")
# 	# plt.plot(x,smoothexp(x,λ=0))

# plt.clf()
# debug()
